#include <bits/stdc++.h>

using namespace std;

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int t,n,k,losi,popularnost=0;
    cin>>t>>n>>k;
    bool moze=true;
    losi=n-k;
    vector<int>br(n),izlaz;
    for(int i=0;i<n;i++){
        cin>>br[i];
    }
    if(losi%2!=0){
        moze=false;
    }
    if(moze){
        losi/=2;
        sort(br.begin(),br.end());
        int pok1=losi-1,pok2=losi;
        for(int i=0;i<n;i++){
            //cout<<popularnost<<" "<<pok1<<" "<<pok2<<endl;
            if(pok2<n && br[pok2]>=popularnost){
                pok2++;
                popularnost++;
                izlaz.push_back(br[pok2-1]);
                //cout<<br[pok2-1]<<" "<<"dobar"<<endl;
            }else if(pok1>=0 && br[pok1]<popularnost){
                pok1--;
                popularnost--;
                izlaz.push_back(br[pok1+1]);
                //cout<<br[pok1+1]<<" "<<"los"<<endl;
            }else{
                moze=false;
            }
        }
    }
    if(moze){
        cout<<"DA"<<endl;
        for(int i=0;i<n;i++){
            cout<<izlaz[i]<<" ";
        }
    }else{
        cout<<"NE"<<endl;
    }
    return 0;
}